#! /usr/bin/ruby
require 'tk'

# biorhythm command
cmd_path = './biorhythm.rb'

# base frame
fb = TkFrame.new.pack('side'=>'top', 'anchor'=>'w')

# birthday
f1 = TkFrame.new(fb).pack('side'=>'top', 'fill'=>'x')
l1 = TkLabel.new(f1, 'text'=>'Your Birthday (YYYYMMDD)').pack('side'=>'left')
e1 = TkEntry.new(f1, 'width'=>9, 'justify'=>'right').pack('side'=>'right')

# date
f2 = TkFrame.new(fb).pack('side'=>'top', 'fill'=>'x')
l2 = TkLabel.new(f2, 'text'=>'Target Day    (YYYYMMDD)').pack('side'=>'left')
e2 = TkEntry.new(f2, 'width'=>9, 'justify'=>'right').pack('side'=>'right')
e2.value = Time.now.strftime("%Y%m%d")

# days
f3 = TkFrame.new(fb).pack('side'=>'top', 'fill'=>'x')
l3 = TkLabel.new(f3, 'text'=>'Display range').pack('side'=>'left')
e3 = TkEntry.new(f3, 'width'=>3, 'justify'=>'right').pack('side'=>'right')
e3.value = 10

# button
f4 = TkFrame.new(fb).pack('side'=>'top', 'fill'=>'x')
b4a = TkButton.new(f4, 'text'=>'exit').pack('side'=>'right', 'anchor'=>'e')
b4b = TkButton.new(f4, 'text'=>'show').pack('side'=>'right', 'anchor'=>'e')

# result display
t = TkText.new(nil, 'width'=>65).pack('side'=>'bottom', 
                                      'fill'=>'both', 'expand'=>true)

# assign command
b4a.command proc{exit}
b4b.command proc{
  open("|ruby #{cmd_path} -g --birthday #{e1.value} --date #{e2.value} --days #{e3.value} 2>&1", 'r'){|fid| t.value = fid.read}
}

# event loop
Tk.mainloop
